SignalRMVCChat/Models/MyWebsite.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Threading.Tasks;
using Newtonsoft.Json;
using SignalRMVCChat.Areas.sysAdmin.Service;
using SignalRMVCChat.DependencyInjection;
using SignalRMVCChat.Models;
using SignalRMVCChat.Models.Alarms;
using SignalRMVCChat.Models.Compaign;
using SignalRMVCChat.Models.ET;
using SignalRMVCChat.Models.HelpDesk;
using SignalRMVCChat.Models.MyWSetting;
using SignalRMVCChat.Models.TelegramBot;
using SignalRMVCChat.WebSocket;
using TelegramBotsWebApplication;
using TelegramBotsWebApplication.Areas.Admin.Service;

namespace SignalRMVCChat.Service
{
    public class MyWebsite : EntitySafeDelete
    {

        
       
        public MyWebsite(string baseUrl)
        {
            TelegramBots = new List<TelegramBotSetting>();
            BaseUrl = baseUrl;
            Admins = new List<MySocket>();
            Customers = new List<MySocket>();
            PluginCustomized = new List<PluginCustomized>();
            Tags = new List<Tag>();
            Forms = new List<Form>();
            HelpDesks = new List<Models.HelpDesk.HelpDesk>();
            EventTriggers = new List<Models.ET.EventTrigger>();
            Bots = new List<Models.Bot.Bot>();
            UsersSeparations = new List<Models.UsersSeparation.UsersSeparation>();
            ReadyPms = new List<Models.ReadyPm.ReadyPm>();
            RemindMes = new List<Models.RemindMe.RemindMe>();
            CompaignTemplates = new List<CompaignTemplate>();
            Compaigns = new List<Models.Compaign.Compaign>();
            Routings = new List<Models.Routing.Routing>();
            MyWebsiteSettings = new List<MyWebsiteSetting>();
        }
        
        
        public MyWebsite()
        {
            Admins = new List<MySocket>();
            Customers = new List<MySocket>();
        }

        public async Task<MySocket> AddOrUpdate(List<MySocket> arr, MySocket con, MyWebSocketRequest request)
        {

            if (string.IsNullOrEmpty(con.Token))
            {
                throw new Exception("کانکشن بدون توکن نباید ذخیره شود");
            }
            
            
            var mySocketService=Injector.Inject<MySocketService>();

            var index = arr.FindIndex(a => a.CustomerId == con.CustomerId
                                           && a.MyAccountId==con.MyAccountId);
            if (index >= 0)
            {

                if (arr[index].Socket.IsAvailable)
                {
                    // اگر قبلا وصل بوده باشد و الان نیز همان اتصال قدیمی را انجام میدهد
                }
                else
                {
                    // وصل مجدد

                    // بقیه را خبر دار میکند که ادمین دوباره انلاین شد یا کا
                await    new AnotherSideNewOnlineInformerHandler()
                        .InformOnlineStatusAgain(con,request.MyWebsite,request);
                }
                
                //نگه داشتن کد ای دی تا بتوانیم آن را آپدیت نماییم در دیتابیس
                // arr[index].MyConnectionInfo = con.MyConnectionInfo;

                /*
                arr[index].MyConnectionInfo = con.MyConnectionInfo;
                arr[index].Socket = con.Socket;
                con = arr[index];
                */

  
            }
            else
            {
                
           
                        
            }

            // موقعی که کاربر اولین بار است باز می کند یا یک تب جدید باز کرده
           // if (request.Name=="Register" || request.Name=="AdminLogin" || request.Name=="GetClientsListForAdmin")

           var exist= arr.Find(a => a.Token.Equals(con.Token));
           if (index< 0 || exist==null)
           {
                //در هر حالتی یک کانکشن جدید است
                arr.Add(con);
            }
            else
            {
                /*arr[index].MyConnectionInfo = con.MyConnectionInfo;
                arr[index].Socket = con.Socket;
                con = arr[index];*/
                con = arr[index];
            }

            

            if (string.IsNullOrEmpty(con.Token)==false)
            {
                if (MyGlobal.IsUnitTestEnvirement)
                {
                    mySocketService.Save(con);
                }
                else
                {
                    if (con.Id==0)
                    {
                        try
                        {
                            mySocketService.SaveWithAttach(con);
                        }
                        catch (Exception e)
            {SignalRMVCChat.Service.LogService.Log(e);
                            throw new FindAndSetExcaption();
                        }
                    }
                    /*else
                    {
                        mySocketService.Update(con);
                    }*/
                }
            }

            return con;



        }

      
        public string BaseUrl { get; set; }

        public MyAccount MyAccount { get; set; }
        public int? MyAccountId { get; set; }
        public string WebsiteToken { get; set; }
        
        public  List<MySocket> Admins { get;set; }
        public  List<MySocket> Customers { get; set; }
        public List<PluginCustomized> PluginCustomized { get; set; }
        public string WebsiteTitle { get; set; }
        public List<Form> Forms { get; set; }
        public List<Category> Categories { get; set; }
        public List<Models.HelpDesk.HelpDesk> HelpDesks { get; set; }
        public List<Models.ET.EventTrigger> EventTriggers { get; set; }
        public List<Models.UsersSeparation.UsersSeparation> UsersSeparations { get; set; }
        public List<Models.RemindMe.RemindMe> RemindMes { get; set; }
        public List<Models.ReadyPm.ReadyPm> ReadyPms { get; set; }
        public List<Models.Bot.Bot> Bots { get; set; }
        public List<Tag> Tags { get; set; }
        public List<Models.Routing.Routing> Routings { get; set; }
        public List<Models.Compaign.Compaign> Compaigns { get; set; }
        public List<CompaignTemplate> CompaignTemplates { get;  set; }
        public List<TelegramBotSetting> TelegramBots { get;  set; }
        public List<MyWebsiteSetting> MyWebsiteSettings { get;  set; }
        public List<Alarm> Alarms { get;  set; }
    }
}

SignalRMVCChat/Areas/Customer/Controllers/MyWebsitesController.cs
using System;
using System.Web.Mvc;
using SignalRMVCChat.Areas.security.Service;
using SignalRMVCChat.DependencyInjection;
using SignalRMVCChat.Service;
using SignalRMVCChat.SysAdmin.Service;
using TelegramBotsWebApplication.ActionFilters;
using TelegramBotsWebApplication.Areas.Admin.Controllers;
using TelegramBotsWebApplication.Areas.Admin.Models;

namespace SignalRMVCChat.Areas.Customer.Controllers
{
    
    [TelegramBotsWebApplication.ActionFilters.MyControllerFilter]
    [MyAuthorizeFilter]
    public class MyWebsitesController:GenericController<MyWebsite>
    {

        public MyWebsitesController()
        {
            Service =Injector.Inject<MyWebsiteService>();
        }
        protected override void OnException(ExceptionContext filterContext)
        {
            SignalRMVCChat.Models.MySpecificGlobal.OnControllerException(filterContext, ViewData);
        }
        
        public override ActionResult Index(int? take, int? skip,int? dependId)
        {
            take = take ?? 20;
            var tokne=CurrentRequestSingleton.CurrentRequest.Token;
            MyDataTableResponse<MyWebsite> response =
                (Service as MyWebsiteService).GetAsPaging(SecurityService.GetCurrentUser().UserName);
            return View(response);
        }


        /*public ActionResult SelectWebsiteForPluginGeneration()
        {
            return View("SelectWebsiteForPluginGeneration");
        }*/


        public override ActionResult Save(MyWebsite model)
        {

            try
            {
                var uri = new Uri(model.BaseUrl);
                string path = uri.GetLeftPart(UriPartial.Path);

            }
            catch (Exception e)
            {SignalRMVCChat.Service.LogService.Log(e);
                ModelState.AddModelError("","آدرس ارسالی صحیح نیست لطفما مانند نمونه ارسال فرمایید");
                ModelState.AddModelError("","http://www.yoursite.com ");
                return View("Detail",new MyEntityResponse<MyWebsite>
                {
                    Single = model
                });
            }
            
            try
            {


                model.WebsiteTitle= MyWebsiteService.GetWebsiteTitleFromWeb(model.BaseUrl);



                MyEntityResponse<int> response = (Service as MyWebsiteService).SaveInForm(model);
                return RedirectToAction("Index");
            }
            catch (Exception e)
            {SignalRMVCChat.Service.LogService.Log(e);
                ModelState.AddModelError("",e.Message);
                return View("Detail",new MyEntityResponse<MyWebsite>
                {
                    Single = model
                });
            }
        }
    }
}

SignalRMVCChat/Areas/Customer/Views/MyWebsites/Detail.cshtml
@using SignalRMVCChat.Areas.security.Service
@using SignalRMVCChat.Areas.sysAdmin.Service
@using SignalRMVCChat.DependencyInjection
@using SignalRMVCChat.Models
@using SignalRMVCChat.Service
@model TelegramBotsWebApplication.Areas.Admin.Models.MyEntityResponse<SignalRMVCChat.Service.MyWebsite>

@{
    ViewBag.Title = "آدرس وب سایتی که مایل هستید گپ چت در آن نصب شود :";
        Layout = "../../Views/Shared/_Layout_Customer.cshtml";


    var myAccountProviderService = Injector.Inject<MyAccountProviderService>();
    MyAccount myAccount=  myAccountProviderService
        .GetAccountIdByUsername(SecurityService.GetCurrentUser().UserName);
}


<div class="card">
                                                    <div class="card-header">
                                                        <h5>@ViewBag.Title </h5>
                                                    </div>
<div class="card-block">


    @using (Html.BeginForm("Save", "MyWebsites", FormMethod.Post))
    {
                               @Html.ValidationSummary("", new { @class = "text-danger" })

        <label>
            آدرس وب سایت 
        </label>
        <input value="@Model.Single.BaseUrl" placeholder=" @MyGlobal.GetBaseUrl(Request.Url)" 
               style="width: 100%;text-align: left;direction: ltr" name="BaseUrl"/>

                                                                                 
@Html.Hidden("MyAccountId",myAccount.Id)
        <hr/>
        <input type="submit" value="ثبت" class="btn btn-primary"/>
        
    
    }


</div>
</div>

SignalRMVCChat/Areas/Customer/Views/MyWebsites/Index.cshtml
@model TelegramBotsWebApplication.Areas.Admin.Models.MyDataTableResponse<SignalRMVCChat.Service.MyWebsite>

@{
    ViewBag.Title = "وب سایت های من";
    Layout = "../../Views/Shared/_Layout_Customer.cshtml";
}
<style>
    
th{
    text-align: right !important;
    direction: rtl!important;
}
</style>

<div class="card">
                                                    <div class="card-header">
                                                        <h5>@ViewBag.Title </h5>
                                                    </div>
<div class="card-block">
                                                       


    <a href="/customer/MyWebsites/Detail?id=0">ایجاد وب سایت جدید</a>
    
    <p>با کلیک بر روی دکمه های زیر می توانید برای هر وب سایت پلاگین مخصوص اش را دانلود نمایید</p>
    @if (Model.EntityList!=null && Model.EntityList.Count > 0)
    {
    <table class="table">
        <thead>

        <tr>
            <th>آدرس وب سایت</th>
            <th colspan="3"></th>

        </tr>
        </thead>
        <tbody>
        @foreach (var rec in Model.EntityList)
        {
            <tr>
                <td>@rec.BaseUrl</td>
                <td>
                    <a href="/Customer/Dashboard/CreatePluginForCustomers?websiteId=@rec.Id" class="btn btn-download">پلاگین مشتریان</a>
                </td>
                <td>
                    <a href="/Customer/Dashboard/CreatePluginForAdmins?websiteId=@rec.Id" class="btn btn-blog">پلاگین پشتیبانی و ادمین</a>
                </td>
                <td>
                    <a href="/Customer/PluginCustomized/Detail?websiteId=@rec.Id" class="btn btn-blog">سفارشی سازی پلاگین</a>
                </td>
   <td><form method="post" action="/Customer/MyWebsites/Delete?id=@rec.Id">
                    
                    <input hidden="hidden" name="Id" value="@rec.Id"/>
                    
                    <button type="submit" class="btn btn-danger">حذف</button>
                    </form></td>
            </tr>
        }
        </tbody>
    </table>

    }
    else
    {
        <p>در حال حاضر هیچ وب سایتی ثبت نشده است برای شروع یک وب سایت <a href="/customer/MyWebsites/Detail?id=0">ایجاد</a> نموده و پلاگین برای آن تولید نمایید</p>
    }
    
</div>
</div>

SignalRMVCChat/Areas/Customer/Views/MyWebsites/SelectWebsiteForPluginGeneration.cshtml
@using SignalRMVCChat.DependencyInjection
@using SignalRMVCChat.Service
@model dynamic

@{
    ViewBag.Title = "انتخاب وبسایت شما جهت ایجاد افزونه";
    Layout = "~/Areas/Customer/Views/Shared/_Layout_Customer.cshtml";
}

<h2>انتخاب وبسایت شما جهت ایجاد افزونه</h2>
@{
    var myWebsiteService = Injector.Inject<MyWebsiteService>();
    var myWebsites = myWebsiteService.GetQuery().ToList();
}

@if (myWebsites != null && myWebsites.Count > 0)
{
    <table class="table">
        <thead>

        <tr>
            <th>آدرس وب سایت</th>
            <th></th>

        </tr>
        </thead>
        <tbody>
        @foreach (var rec in myWebsites)
        {
            <tr>
                <td>@rec.BaseUrl</td>
                <td>
                    <a href="/Customer/Dashboard/CreatePluginForCustomers?websiteId=@rec.Id" class="btn btn-download">پلاگین مشتریان</a>
                </td>
                <td>
                    <a href="/Customer/Dashboard/CreatePluginForAdmins?websiteId=@rec.Id" class="btn btn-blog">پلاگین پشتیبانی و ادمین</a>
                </td>
   <td><form method="post" action="/Customer/MyWebsites/Delete?id=@rec.Id">
                    
                    <input hidden="hidden" name="Id" value="@rec.Id"/>
                    
                    <button type="submit" class="btn btn-danger">حذف</button>
                    </form></td>
            </tr>
        }
        </tbody>
    </table>
}
else
{
    <p>در حال حاضر هیچ وب سایتی ثبت نشده است برای شروع یک وب سایت <a href="/customer/MyWebsites/Detail?id=0">ایجاد</a> نموده و پلاگین برای آن تولید نمایید</p>
}